From 294f2d86c05046c6b300c7d94617da3f922e92e1 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?C=C3=A9lestin=20Matte?= <gitlab@cmatte.me>
Date: Wed, 22 Mar 2023 15:33:20 +0100
Subject: [PATCH] load_message: catch postgres UniqueViolation errors when
 importing messages

When importing an entire mbox, commit at every message, and rollback in case
of an error with a message to be able to keep importing the rest of the mbox
---
 loader/load_message.py | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/loader/load_message.py b/loader/load_message.py
index 2357c6e..7a26f77 100755
--- a/loader/load_message.py
+++ b/loader/load_message.py
@@ -155,7 +155,13 @@ if __name__ == "__main__":
                 log_failed_message(listid, "mbox", opt.mbox, ap, e)
                 opstatus.failed += 1
                 continue
-            ap.store(conn, listid, opt.overwrite, opt.overwrite)
+            try:
+                ap.store(conn, listid, opt.overwrite, opt.overwrite)
+                conn.commit()
+            except psycopg2.errors.UniqueViolation as e:
+                curs.execute("rollback")
+                log_failed_message(listid, "mbox", opt.mbox, ap, "Failed loading message: already present in another list: %s" % e)
+                opstatus.failed += 1
             purges.update(ap.purges)
         if mboxparser.returncode():
             log.error("Failed to parse mbox:")
-- 
2.39.2

